/********************************************************************************** 
  This file is part of the kde-game 'ktron'

  Copyright (C) 1998 by Matthias Kiefer <Matthias.Kiefer@stud.uni-karlsruhe.de>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  *******************************************************************************/  

#ifndef APP_H
#define APP_H


#include <kapp.h>
#include <kmenubar.h>
#include <kstatusbar.h>
#include <ktopwidget.h>

#include "tron.h"

#define ID_GAME_NEW 1
#define ID_GAME_PAUSE 2
#define ID_GAME_QUIT 3
#define ID_HELP_ABOUT 11
#define ID_HELP_CONTENTS 12
#define ID_VIEW_TOOLBAR 15
#define ID_VIEW_STATUSBAR 16
#define ID_OPT_KEYS 21
#define ID_OPT_SAVE 22
#define ID_COLOR_BASE 30 
#define ID_STATUS_BASE 40
#define ID_VELOCITY_BASE 50
#define ID_COMP_BASE 60
#define ID_STYLE_BASE 70
#define ID_SIZE_BASE 100

class App : public KTopLevelWidget
{
 Q_OBJECT
public:
 App(const char *name=0); // Konstruktor
 ~App();                  // Destruktor

private:
 KMenuBar *menu;         // Menubar
 KToolBar *toolbar;
 KStatusBar *statusbar;
 QPopupMenu *velocity;
 QPopupMenu *options;
 QPopupMenu *viewMenu;
 QPopupMenu *compPlayers;
 QPopupMenu *styleMenu;
 QPopupMenu *sizeMenu;
 Tron *tron;
 
 void initmenu();	
 void updateVelocityMenu(int);
 void saveSettings();
 
protected:
 void readProperties(KConfig *);
 void saveProperties(KConfig *);
 
private slots:
   void menuCallback(int);
   void changeStatus(int);
   void removeWinnerMessage();
   void barPositionChanged();
   void placeTronWidget(bool fromResizeEvent);

};

#endif //APP_H







